// Code generated by protoc-gen-go. DO NOT EDIT.
// source: rsphonebook/server/servermodel/recordServer.proto

/*
Package servermodel is a generated protocol buffer package.

It is generated from these files:
	rsphonebook/server/servermodel/recordServer.proto

It has these top-level messages:
	RecordRequest
	RecordResponse
*/
package servermodel

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import clientmodel "rsphonebook/client/clientmodel"
import google_protobuf "github.com/golang/protobuf/ptypes/empty"
import _ "google.golang.org/genproto/googleapis/api/annotations"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type RecordResponse_RespStatus int32

const (
	RecordResponse_OK           RecordResponse_RespStatus = 0
	RecordResponse_NOT_FOUND    RecordResponse_RespStatus = 1
	RecordResponse_BAD_REQUEST  RecordResponse_RespStatus = 2
	RecordResponse_CREATED      RecordResponse_RespStatus = 3
	RecordResponse_SERVER_ERROR RecordResponse_RespStatus = 4
	RecordResponse_UPDATED      RecordResponse_RespStatus = 5
)

var RecordResponse_RespStatus_name = map[int32]string{
	0: "OK",
	1: "NOT_FOUND",
	2: "BAD_REQUEST",
	3: "CREATED",
	4: "SERVER_ERROR",
	5: "UPDATED",
}
var RecordResponse_RespStatus_value = map[string]int32{
	"OK":           0,
	"NOT_FOUND":    1,
	"BAD_REQUEST":  2,
	"CREATED":      3,
	"SERVER_ERROR": 4,
	"UPDATED":      5,
}

func (x RecordResponse_RespStatus) String() string {
	return proto.EnumName(RecordResponse_RespStatus_name, int32(x))
}
func (RecordResponse_RespStatus) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{1, 0} }

type RecordRequest struct {
	Record      *clientmodel.Record `protobuf:"bytes,1,opt,name=record" json:"record,omitempty"`
	Phonenumber string              `protobuf:"bytes,2,opt,name=phonenumber" json:"phonenumber,omitempty"`
}

func (m *RecordRequest) Reset()                    { *m = RecordRequest{} }
func (m *RecordRequest) String() string            { return proto.CompactTextString(m) }
func (*RecordRequest) ProtoMessage()               {}
func (*RecordRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *RecordRequest) GetRecord() *clientmodel.Record {
	if m != nil {
		return m.Record
	}
	return nil
}

func (m *RecordRequest) GetPhonenumber() string {
	if m != nil {
		return m.Phonenumber
	}
	return ""
}

type RecordResponse struct {
	Record *clientmodel.Record       `protobuf:"bytes,1,opt,name=record" json:"record,omitempty"`
	Status RecordResponse_RespStatus `protobuf:"varint,2,opt,name=status,enum=servermodel.RecordResponse_RespStatus" json:"status,omitempty"`
}

func (m *RecordResponse) Reset()                    { *m = RecordResponse{} }
func (m *RecordResponse) String() string            { return proto.CompactTextString(m) }
func (*RecordResponse) ProtoMessage()               {}
func (*RecordResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *RecordResponse) GetRecord() *clientmodel.Record {
	if m != nil {
		return m.Record
	}
	return nil
}

func (m *RecordResponse) GetStatus() RecordResponse_RespStatus {
	if m != nil {
		return m.Status
	}
	return RecordResponse_OK
}

func init() {
	proto.RegisterType((*RecordRequest)(nil), "servermodel.RecordRequest")
	proto.RegisterType((*RecordResponse)(nil), "servermodel.RecordResponse")
	proto.RegisterEnum("servermodel.RecordResponse_RespStatus", RecordResponse_RespStatus_name, RecordResponse_RespStatus_value)
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for PhoneBook service

type PhoneBookClient interface {
	// Все записи из телефонной книги
	ViewAll(ctx context.Context, in *google_protobuf.Empty, opts ...grpc.CallOption) (PhoneBook_ViewAllClient, error)
	// Создание новой записи в тел книге
	AddNewRecord(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error)
	// Поиск записи по номеру телефона
	FindRec(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error)
	// Удаление записи по номеру телефона
	DeleteRec(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error)
	// Обновление записи, найденной по номеру
	UpdateRecord(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error)
}

type phoneBookClient struct {
	cc *grpc.ClientConn
}

func NewPhoneBookClient(cc *grpc.ClientConn) PhoneBookClient {
	return &phoneBookClient{cc}
}

func (c *phoneBookClient) ViewAll(ctx context.Context, in *google_protobuf.Empty, opts ...grpc.CallOption) (PhoneBook_ViewAllClient, error) {
	stream, err := grpc.NewClientStream(ctx, &_PhoneBook_serviceDesc.Streams[0], c.cc, "/servermodel.PhoneBook/ViewAll", opts...)
	if err != nil {
		return nil, err
	}
	x := &phoneBookViewAllClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type PhoneBook_ViewAllClient interface {
	Recv() (*RecordResponse, error)
	grpc.ClientStream
}

type phoneBookViewAllClient struct {
	grpc.ClientStream
}

func (x *phoneBookViewAllClient) Recv() (*RecordResponse, error) {
	m := new(RecordResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *phoneBookClient) AddNewRecord(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error) {
	out := new(RecordResponse)
	err := grpc.Invoke(ctx, "/servermodel.PhoneBook/AddNewRecord", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *phoneBookClient) FindRec(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error) {
	out := new(RecordResponse)
	err := grpc.Invoke(ctx, "/servermodel.PhoneBook/FindRec", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *phoneBookClient) DeleteRec(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error) {
	out := new(RecordResponse)
	err := grpc.Invoke(ctx, "/servermodel.PhoneBook/DeleteRec", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *phoneBookClient) UpdateRecord(ctx context.Context, in *RecordRequest, opts ...grpc.CallOption) (*RecordResponse, error) {
	out := new(RecordResponse)
	err := grpc.Invoke(ctx, "/servermodel.PhoneBook/UpdateRecord", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for PhoneBook service

type PhoneBookServer interface {
	// Все записи из телефонной книги
	ViewAll(*google_protobuf.Empty, PhoneBook_ViewAllServer) error
	// Создание новой записи в тел книге
	AddNewRecord(context.Context, *RecordRequest) (*RecordResponse, error)
	// Поиск записи по номеру телефона
	FindRec(context.Context, *RecordRequest) (*RecordResponse, error)
	// Удаление записи по номеру телефона
	DeleteRec(context.Context, *RecordRequest) (*RecordResponse, error)
	// Обновление записи, найденной по номеру
	UpdateRecord(context.Context, *RecordRequest) (*RecordResponse, error)
}

func RegisterPhoneBookServer(s *grpc.Server, srv PhoneBookServer) {
	s.RegisterService(&_PhoneBook_serviceDesc, srv)
}

func _PhoneBook_ViewAll_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(google_protobuf.Empty)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(PhoneBookServer).ViewAll(m, &phoneBookViewAllServer{stream})
}

type PhoneBook_ViewAllServer interface {
	Send(*RecordResponse) error
	grpc.ServerStream
}

type phoneBookViewAllServer struct {
	grpc.ServerStream
}

func (x *phoneBookViewAllServer) Send(m *RecordResponse) error {
	return x.ServerStream.SendMsg(m)
}

func _PhoneBook_AddNewRecord_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RecordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PhoneBookServer).AddNewRecord(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/servermodel.PhoneBook/AddNewRecord",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PhoneBookServer).AddNewRecord(ctx, req.(*RecordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PhoneBook_FindRec_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RecordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PhoneBookServer).FindRec(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/servermodel.PhoneBook/FindRec",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PhoneBookServer).FindRec(ctx, req.(*RecordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PhoneBook_DeleteRec_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RecordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PhoneBookServer).DeleteRec(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/servermodel.PhoneBook/DeleteRec",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PhoneBookServer).DeleteRec(ctx, req.(*RecordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PhoneBook_UpdateRecord_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RecordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PhoneBookServer).UpdateRecord(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/servermodel.PhoneBook/UpdateRecord",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PhoneBookServer).UpdateRecord(ctx, req.(*RecordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _PhoneBook_serviceDesc = grpc.ServiceDesc{
	ServiceName: "servermodel.PhoneBook",
	HandlerType: (*PhoneBookServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "AddNewRecord",
			Handler:    _PhoneBook_AddNewRecord_Handler,
		},
		{
			MethodName: "FindRec",
			Handler:    _PhoneBook_FindRec_Handler,
		},
		{
			MethodName: "DeleteRec",
			Handler:    _PhoneBook_DeleteRec_Handler,
		},
		{
			MethodName: "UpdateRecord",
			Handler:    _PhoneBook_UpdateRecord_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ViewAll",
			Handler:       _PhoneBook_ViewAll_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "rsphonebook/server/servermodel/recordServer.proto",
}

func init() { proto.RegisterFile("rsphonebook/server/servermodel/recordServer.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 505 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x92, 0x4f, 0x6f, 0xd3, 0x30,
	0x18, 0xc6, 0x49, 0x19, 0xad, 0xea, 0xb4, 0x5b, 0x64, 0x04, 0x4c, 0xe1, 0x8f, 0xa2, 0x1c, 0xa6,
	0x6a, 0x53, 0x1d, 0xe8, 0x6e, 0x1c, 0x90, 0x32, 0x92, 0x5d, 0x90, 0xda, 0xe1, 0xb6, 0xe3, 0x46,
	0x49, 0xea, 0xb7, 0x59, 0x58, 0x6a, 0x87, 0xc4, 0x59, 0x35, 0x21, 0x2e, 0x7c, 0x02, 0x24, 0x3e,
	0x1a, 0x1f, 0x80, 0x0b, 0x1f, 0x04, 0xd5, 0x49, 0x21, 0x48, 0xd3, 0x24, 0x60, 0x97, 0x38, 0xf2,
	0xfb, 0x3e, 0xcf, 0xcf, 0x7e, 0x1f, 0xa3, 0x67, 0x59, 0x9e, 0x9e, 0x09, 0x0e, 0xa1, 0x10, 0xe7,
	0x4e, 0x0e, 0xd9, 0x05, 0x64, 0xd5, 0xb2, 0x14, 0x0c, 0x12, 0x27, 0x83, 0xb9, 0xc8, 0xd8, 0x58,
	0xed, 0x90, 0x34, 0x13, 0x52, 0x60, 0xbd, 0x56, 0x37, 0x0f, 0xea, 0xfa, 0x79, 0x12, 0x03, 0x97,
	0xd5, 0x52, 0xd7, 0x97, 0x4a, 0xf3, 0x30, 0x8a, 0xe5, 0x59, 0x11, 0x92, 0xb9, 0x58, 0x3a, 0x91,
	0x48, 0x02, 0x1e, 0x39, 0xaa, 0x10, 0x16, 0x0b, 0x27, 0x95, 0x97, 0x29, 0xe4, 0x0e, 0x2c, 0x53,
	0x79, 0x59, 0x7e, 0x2b, 0xd1, 0xa3, 0x48, 0x88, 0x28, 0x01, 0x27, 0x48, 0x63, 0x27, 0xe0, 0x5c,
	0xc8, 0x40, 0xc6, 0x82, 0xe7, 0x65, 0xd5, 0x7e, 0x8b, 0xba, 0x54, 0x21, 0x28, 0x7c, 0x28, 0x20,
	0x97, 0xf8, 0x00, 0x35, 0x4b, 0xe6, 0xae, 0x66, 0x69, 0x3d, 0x7d, 0x70, 0x97, 0xd4, 0x8e, 0x43,
	0xaa, 0xde, 0xaa, 0x05, 0x5b, 0x48, 0x57, 0xa7, 0xe7, 0xc5, 0x32, 0x84, 0x6c, 0xb7, 0x61, 0x69,
	0xbd, 0x36, 0xad, 0x6f, 0xd9, 0xdf, 0x35, 0xb4, 0xbd, 0x01, 0xe4, 0xa9, 0xe0, 0x39, 0xfc, 0x1d,
	0xe1, 0x05, 0x6a, 0xe6, 0x32, 0x90, 0x45, 0xae, 0xcc, 0xb7, 0x07, 0x7b, 0xa4, 0x36, 0x3d, 0xf2,
	0xa7, 0x33, 0x59, 0xff, 0x8c, 0x55, 0x37, 0xad, 0x54, 0xf6, 0x3b, 0x84, 0x7e, 0xef, 0xe2, 0x26,
	0x6a, 0x8c, 0x5e, 0x19, 0xb7, 0x70, 0x17, 0xb5, 0x87, 0xa3, 0xc9, 0xec, 0x78, 0x34, 0x1d, 0x7a,
	0x86, 0x86, 0x77, 0x90, 0x7e, 0xe4, 0x7a, 0x33, 0xea, 0xbf, 0x9e, 0xfa, 0xe3, 0x89, 0xd1, 0xc0,
	0x3a, 0x6a, 0xbd, 0xa4, 0xbe, 0x3b, 0xf1, 0x3d, 0xe3, 0x36, 0x36, 0x50, 0x67, 0xec, 0xd3, 0x53,
	0x9f, 0xce, 0x7c, 0x4a, 0x47, 0xd4, 0xd8, 0x5a, 0x97, 0xa7, 0x27, 0x9e, 0x2a, 0xdf, 0x19, 0x7c,
	0xd9, 0x42, 0xed, 0x93, 0xf5, 0x8d, 0x8f, 0x84, 0x38, 0xc7, 0x6f, 0x50, 0xeb, 0x34, 0x86, 0x95,
	0x9b, 0x24, 0xf8, 0x3e, 0x29, 0x27, 0x4f, 0x36, 0x19, 0x11, 0x7f, 0x1d, 0x8b, 0xf9, 0xf0, 0x9a,
	0x2b, 0xd8, 0xf7, 0x3e, 0x7f, 0xfb, 0xf1, 0xb5, 0xb1, 0x83, 0xbb, 0x2a, 0xaf, 0x8b, 0x18, 0x56,
	0x7d, 0x37, 0x49, 0x9e, 0x6a, 0x78, 0x81, 0x3a, 0x2e, 0x63, 0x43, 0x58, 0x95, 0x02, 0x6c, 0x5e,
	0xe9, 0xa2, 0x32, 0xbc, 0x9e, 0xf0, 0x58, 0x11, 0x1e, 0xd8, 0xb8, 0x7c, 0x11, 0x8c, 0xf5, 0x7f,
	0x99, 0x3e, 0xd7, 0xf6, 0xf1, 0x7b, 0xd4, 0x3a, 0x8e, 0x39, 0xa3, 0x30, 0xff, 0x77, 0xc4, 0x9e,
	0x42, 0x58, 0xf8, 0x89, 0x42, 0x2c, 0x62, 0xce, 0xfa, 0x65, 0x87, 0xf3, 0xb1, 0xf6, 0x36, 0x3e,
	0x61, 0x8e, 0xda, 0x1e, 0x24, 0x20, 0xe1, 0xbf, 0x68, 0x3d, 0x45, 0xb3, 0xf7, 0x2d, 0x45, 0x63,
	0xca, 0xf0, 0x6a, 0xde, 0x02, 0x75, 0xa6, 0x29, 0x0b, 0x14, 0xef, 0x26, 0x66, 0x68, 0x96, 0x33,
	0x2c, 0x94, 0x67, 0x3f, 0xdb, 0xcc, 0x30, 0x6c, 0xaa, 0xc4, 0x0f, 0x7f, 0x06, 0x00, 0x00, 0xff,
	0xff, 0xe9, 0x4e, 0xc1, 0xca, 0x1d, 0x04, 0x00, 0x00,
}
